import os.path as path
import json
import socket

class Module:
    def __init__(self, incoming=False, verbose=False, options=None):
        # extract the file name from __file__. __file__ is proxymodules/name.py
        self.name = path.splitext(path.basename(__file__))[0]
        self.description = 'Simply print the received data as text'
        self.incoming = incoming  # incoming means module is on -im chain
        self.find = None  # if find is not None, this text will be highlighted

    # protocol 4: flag{4uth3nt1c4t10n_1s_1mp0rt4nt}
    def execute(self, data):
        print(f"Incoming data: {data}")

        data_json = json.loads(data)
        if data_json["id"] == 2:
            # Send Nonce N_S back to S without Alice encrypting it
            data_json["id"] = 3
            data_json["sender"], data_json["receiver"] = data_json["receiver"], data_json["sender"]
        elif data_json["id"] == 4:
            # Reflect message back to S so that T does not decrypt it
            data_json["id"] = 5
            data_json["sender"], data_json["receiver"] = data_json["receiver"], data_json["sender"]
            
        data = bytes(json.dumps(data_json).replace(" ", "") + "\n", 'utf-8')
        print(f"Outgoing data: {data}")
        return data


if __name__ == '__main__':
    print('This module is not supposed to be executed alone!')